// DirectDrawSurface.h: CDirectDrawSurface NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRECTDRAWSURFACE_H__1856BEA9_9276_11D2_B314_AB4C337AF61F__INCLUDED_)
#define AFX_DIRECTDRAWSURFACE_H__1856BEA9_9276_11D2_B314_AB4C337AF61F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDirectDrawSurface  
{
public:
	CDirectDrawSurface();
	virtual ~CDirectDrawSurface();
	void Initialize(IDirectDrawSurface4** pSuf);
	void Release();

	HRESULT Blt( RECT* rcTo , CDirectDrawSurface* pSuf , RECT* rcFrom , DWORD flags , DDBLTFX* fx );
	void SetColorKey( COLORREF cl );

	HRESULT GetDC(HDC* pHDC);
	void ReleaseDC(HDC hdc);

	bool Lock();
	BYTE* GetHeadPtr(int line);
	DWORD GetOffset();
	DWORD RGB2SRF( int r,int g,int b );
	void SRF2RGB( DWORD dw , int* r, int* g, int* b );

	void SetPixelDD( BYTE* p , DWORD cl );
	void GetPixelDD( BYTE* p , DWORD* pD );

	void Unlock();


	int Width(){return m_Width;};
	int Height(){return m_Height;};

private:
	IDirectDrawSurface4* m_pSurface;
	int m_Width;
	int m_Height;
	int m_BPP;

	bool m_bLocked;
	DDSURFACEDESC2 m_Desc;

	DWORD m_RShift,m_GShift,m_BShift;
	DWORD m_RBits,m_GBits,m_BBits;
	DWORD m_RMask,m_GMask,m_BMask;

	friend class CDirect3DRM;
	friend class CDirect3DIM;
};

#endif // !defined(AFX_DIRECTDRAWSURFACE_H__1856BEA9_9276_11D2_B314_AB4C337AF61F__INCLUDED_)
