// GrobalMain.h: CGrobalMain NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GROBALMAIN_H__077C6483_935D_11D2_B314_DE15839C9229__INCLUDED_)
#define AFX_GROBALMAIN_H__077C6483_935D_11D2_B314_DE15839C9229__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/// Classes ////////
#include "DirectDraw.h"
#include "DirectDrawSurface.h"
#include "DirectSound.h"
#include "DirectSoundBuffer.h"
#include "DirectInput.h"

#include "Charactor.h"

class CGrobalMain
{
	friend class CDirectSoundBuffer;
public:
	CGrobalMain();
	virtual ~CGrobalMain();

	void Start( HINSTANCE hi,HWND hw );
	void End();

	void Timer( UINT ID );
	void Activate( BOOL bAtctive );
	void EndTimer();
	void StartTimer();

	UINT m_midi;
	void PlayMIDI();
	void ReplayMIDI();
	char m_CurrentMIDI[_MAX_PATH];

	static void CALLBACK MMTimerProc( UINT uID , UINT uMsg , DWORD dwUser , DWORD dw1 , DWORD dw2 );

private:
	UINT m_TimerID;
	HWND m_hWnd;
	HINSTANCE m_hInstance;
	bool m_bActive;
	CDirectDraw dd;
	CDirectDrawSurface* pbk;
	CDirectSound ds;
	CDirectInput di;

protected:
	enum { TITLE , OPTION , VS_COM , VS_2P } m_Mode;
	enum { CHARSEL , STORY , WIN , BATTLE , STOP } m_ModeDetail;

	void TitleProc();
	void OptionProc();
	void VsProc();

	void CharSelProc();
	void WinProc();
	void StoryProc();

// TITLE
	int m_TitleSel;
	CDirectDrawSurface m_TitleS;
// OPTION
	int m_OptionSel;
	CDirectDrawSurface m_OptionS;
// VS_2P
// VS_COM
	int m_BattleNo;

	CDirectDrawSurface m_WakuRS;
	CDirectDrawSurface m_WakuBS;
	int m_Chara0No;
	int m_Chara1No;
	bool m_bCom0;
	bool m_bCom1;

	CDirectDrawSurface m_BackS;
	CDirectDrawSurface m_ShoriS;
	CDirectDrawSurface m_StartS;
	CDirectDrawSurface m_StoryS;
	CCharactor* m_pCh0;
	CCharactor* m_pCh1;

// [hʃf[^
	CDirectSoundBuffer Saa;
	CDirectSoundBuffer Tirolin;
	CDirectSoundBuffer Boon;

	CDirectDrawSurface m_CurLightS;
	CDirectDrawSurface m_CurDarkS;
	bool m_bMIDI;
	bool m_bSOUND;
	int m_SkipFrame;
	int m_Res;

	CCharactor m_CharaList[8];
};

#endif // !defined(AFX_GROBALMAIN_H__077C6483_935D_11D2_B314_DE15839C9229__INCLUDED_)
